"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");exports.__esModule=true;exports.default=void 0;var _defineProperty2=_interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));function ownKeys(e,r){var t=Object.keys(e);if(Object.getOwnPropertySymbols){var o=Object.getOwnPropertySymbols(e);r&&(o=o.filter((function(r){return Object.getOwnPropertyDescriptor(e,r).enumerable}))),t.push.apply(t,o)}return t}function _objectSpread(e){for(var r=1;r<arguments.length;r++){var t=null!=arguments[r]?arguments[r]:{};r%2?ownKeys(Object(t),!0).forEach((function(r){(0,_defineProperty2.default)(e,r,t[r])})):Object.getOwnPropertyDescriptors?Object.defineProperties(e,Object.getOwnPropertyDescriptors(t)):ownKeys(Object(t)).forEach((function(r){Object.defineProperty(e,r,Object.getOwnPropertyDescriptor(t,r))}))}return e}var getMultiplierOfFr=function getMultiplierOfFr(size){return+size.replace(/fr/,"")},_frSpaceDistributorHelper2=function _frSpaceDistributorHelper(tracks,totalSpaceUsed,containerSize){var freeSpace,spacePerFrTrack,eligibleTracks,totalFrTrackRatio=0;if(!tracks.length){return}tracks.forEach((function(track){return totalFrTrackRatio+=track.multiplier}));freeSpace=containerSize-totalSpaceUsed;spacePerFrTrack=freeSpace/totalFrTrackRatio;eligibleTracks=tracks.filter((function(track){return track.baseSize<=track.multiplier*spacePerFrTrack}));if(eligibleTracks.length<tracks.length){tracks.filter((function(track){return track.baseSize>track.multiplier*spacePerFrTrack})).forEach((function(track){return totalSpaceUsed+=track.baseSize}));return _frSpaceDistributorHelper2(eligibleTracks,totalSpaceUsed,containerSize)}else{eligibleTracks.forEach((function(track){return track.baseSize=track.multiplier*spacePerFrTrack}))}},_intrinsicSpaceDistributorHelper=function _intrinsicSpaceDistributorHelper(tracks,totalSpaceUsed,containerSize){var freeSpace,spacePerIntrinsicTrack,i,len,frozenTrack=0,minMaxTracks,growthLimit,baseSize;if(!tracks.length){return}minMaxTracks=tracks.filter((function(track){return track.type==="minmax"&&track.growthLimit!==Infinity}));freeSpace=containerSize-totalSpaceUsed;minMaxTracks.sort((function(a,b){var gap1=a.growthLimit-a.baseSize,gap2=b.growthLimit-b.baseSize;return gap1-gap2}));len=minMaxTracks.length;while(frozenTrack<len&&freeSpace){spacePerIntrinsicTrack=freeSpace/(minMaxTracks.length-frozenTrack||1);for(i=0,len=minMaxTracks.length;i<len;i++){growthLimit=minMaxTracks[i].growthLimit;baseSize=Math.min(spacePerIntrinsicTrack+minMaxTracks[i].baseSize,growthLimit);freeSpace-=baseSize-minMaxTracks[i].baseSize;minMaxTracks[i].baseSize=baseSize;if(growthLimit===baseSize&&!minMaxTracks[i].frozen){minMaxTracks[i].frozen=true;frozenTrack++}}}tracks=tracks.filter((function(track){return track.type==="minmax"&&track.growthLimit===Infinity||track.type!=="minmax"}));spacePerIntrinsicTrack=freeSpace/tracks.length;tracks.forEach((function(track){return track.baseSize+=spacePerIntrinsicTrack}))};var TrackResolver=function(){function TrackResolver(tracks,items,containerSize){if(tracks===void 0){tracks=[]}if(items===void 0){items=[]}if(containerSize===void 0){containerSize=600}this.clear();this.set("tracks",tracks);this.set("items",items);this.set("containerSize",containerSize);return this}var _proto=TrackResolver.prototype;_proto.set=function set(key,info){this.props[key]=info;switch(key){case"tracks":this._initTrackSize();break;case"items":this._initItems();break;case"containerSize":this.props[key]=isNaN(+info)?0:+info}return this};_proto.get=function get(key){return this.props[key]};_proto._initTrackSize=function _initTrackSize(_tracks){var tracks=_tracks||this.props.tracks||[],config=this._config,trackAr=[{}],i,len,size,type,multiplier,baseSize,growthLimit;config.frTracks=[];config.intrinsicTracks=[];for(i=1,len=tracks.length;i<len;i++){size=tracks[i].size;multiplier=1;if(Array.isArray(size)){baseSize=+size[0]||0;if(size[1].indexOf("fr")>0||size[0].indexOf("fr")>0){growthLimit=Infinity;config.frTracks.push(i);type="minmax"}else if(size[1]==="auto"||size[0]==="auto"){growthLimit=Infinity;config.intrinsicTracks.push(i);type="minmax"}else if(!isNaN(+size[0])&&!isNaN(+size[1])){growthLimit=Math.max(+size[0],+size[1]);baseSize=Math.min(+size[0],+size[1]);config.intrinsicTracks.push(i);type="minmax"}}else if(!isNaN(+size)){baseSize=growthLimit=+size;type="fixed"}else if(size.indexOf("fr")>0){baseSize=0;growthLimit=Infinity;config.frTracks.push(i);type="flex";multiplier=getMultiplierOfFr(size)}else{baseSize=0;growthLimit=Infinity;type="intrinsic";config.intrinsicTracks.push(i)}trackAr.push(_objectSpread(_objectSpread({},tracks[i]),{},{type:type,multiplier:multiplier,baseSize:baseSize,growthLimit:growthLimit}))}return config.sanitizedTracks=trackAr};_proto._initItems=function _initItems(_items){var items=_items||this.props.items||[],config=this._config,sanitizedItems=[],nonSpanningItemStartIndex,item,validItems=0,i,len;for(i=0,len=items.length;i<len;i++){if(isNaN(items[i].start)||isNaN(items[i].end)){config.autoFlow.push(items[i]);continue}sanitizedItems.push(_objectSpread({},items[i]));item=sanitizedItems[validItems];validItems++;item.size=isNaN(item.size)?this._getParentSize(item):+item.size}sanitizedItems.sort((function(a,b){var gap1=a.end-a.start,gap2=b.end-b.start;if(gap1===gap2){return a.start-b.start}else{return gap1-gap2}}));for(i=0,nonSpanningItemStartIndex=len=sanitizedItems.length;i<len;i++){if(sanitizedItems[i].end-sanitizedItems[i].start>1){nonSpanningItemStartIndex=i;break}}this._config.nonSpanningItemStartIndex=nonSpanningItemStartIndex;return this._config.sanitizedItems=sanitizedItems};_proto._getParentSize=function _getParentSize(item){var sanitizedTracks=this._config.sanitizedTracks,parentTracks,widthOfParentTracks=0;parentTracks=sanitizedTracks.filter((function(track){return track.start>=item.start&&track.end<=item.end}));parentTracks.forEach((function(track){return widthOfParentTracks+=track.baseSize}));return widthOfParentTracks||0};_proto.resolveTracks=function resolveTracks(){this._placeNonSpanningItems()._placeSpanningItems()._distributeFreeSpace();return this._config.sanitizedTracks};_proto._placeNonSpanningItems=function _placeNonSpanningItems(){var _this$_config=this._config,sanitizedItems=_this$_config.sanitizedItems,sanitizedTracks=_this$_config.sanitizedTracks,nonSpanningItemStartIndex=_this$_config.nonSpanningItemStartIndex,nonSpanningItems=sanitizedItems.slice(0,nonSpanningItemStartIndex),track,trackIndex;nonSpanningItems.forEach((function(item){trackIndex=item.start;track=sanitizedTracks[trackIndex];if(track.type!=="fixed"){track.baseSize=Math.max(track.baseSize,item.size);track.growthLimit=Math.max(track.growthLimit,track.baseSize)}}));return this};_proto._placeSpanningItems=function _placeSpanningItems(){var _this$_config2=this._config,sanitizedItems=_this$_config2.sanitizedItems,sanitizedTracks=_this$_config2.sanitizedTracks,nonSpanningItemStartIndex=_this$_config2.nonSpanningItemStartIndex,frTracks=_this$_config2.frTracks,spanningItems=sanitizedItems.slice(nonSpanningItemStartIndex),trackSizedp=[0],sizeConsumed,sizeLeft,sizePerTrack,availableTracks,hasFrTrack,i,len;if(!spanningItems.length)return this;for(i=1,len=sanitizedTracks.length;i<len;i++){trackSizedp[i]=trackSizedp[i-1]+(sanitizedTracks[i].baseSize||0)}spanningItems.forEach((function(item){sizeConsumed=trackSizedp[item.end-1]-trackSizedp[item.start-1];sizeLeft=Math.max(0,item.size-sizeConsumed);if(!sizeLeft)return;for(i=item.start,hasFrTrack=false,availableTracks=0;i<item.end;i++){if(frTracks.indexOf(i)>=0){hasFrTrack=true}if(sanitizedTracks[i].type!=="fixed"){availableTracks++}}if(!availableTracks||hasFrTrack)return;sizePerTrack=sizeLeft/availableTracks;for(i=item.start;i<item.end;i++){if(sanitizedTracks[i].type!=="fixed"){sanitizedTracks[i].baseSize+=sizePerTrack}}}));return this};_proto._distributeFreeSpace=function _distributeFreeSpace(){var _this$_config3=this._config,frTracks=_this$_config3.frTracks,intrinsicTracks=_this$_config3.intrinsicTracks,sanitizedTracks=_this$_config3.sanitizedTracks,containerSize=this.props.containerSize,totalSpaceUsed=0;sanitizedTracks.forEach((function(track){return totalSpaceUsed+=track.baseSize||0}));if(totalSpaceUsed<containerSize){if(frTracks.length){frTracks.forEach((function(trackId,index){frTracks[index]=sanitizedTracks[trackId]}));frTracks.forEach((function(track){return totalSpaceUsed-=track.baseSize}));_frSpaceDistributorHelper2(frTracks,totalSpaceUsed,containerSize)}else if(intrinsicTracks.length){intrinsicTracks.forEach((function(trackId,index){intrinsicTracks[index]=sanitizedTracks[trackId]}));_intrinsicSpaceDistributorHelper(intrinsicTracks,totalSpaceUsed,containerSize)}}return this};_proto.clear=function clear(){this.props={};this._config={frTracks:[],intrinsicTracks:[],autoFlow:[]};return this};return TrackResolver}();var _default=exports.default=TrackResolver;