"use strict";var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");exports.__esModule=true;exports.default=void 0;var _inheritsLoose2=_interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));var _componentInterface=require("../component-interface");var _colorBucket=_interopRequireDefault(require("./color-bucket"));var _gradientColorRange=_interopRequireDefault(require("./gradient-color-range"));var _lib=require("../lib");var GRADIENT="gradient",ICON="icon",NONE="none";function getOppositeColor(code){return(0,_lib.getLightColor)(code,1)}function getValidHexColor(code){var color=code||DEF_COLOR;return(0,_lib.getValidColor)(color)||DEF_COLOR}var TRACKER_FILL="rgba(192,192,192,"+(_lib.isIE?.002:1e-6)+")",UNDEF,PERCENT_STR="%",DEF_COLOR="#000000",legendManager=function(){var chart,defaultConf={};defaultConf.legendCarpetConf={spreadFactor:.85,allowDrag:false,captionAlignment:"center",padding:{v:3,h:3},style:{fill:"#e4d9c1",stroke:"#c4b89d"}};defaultConf.legendCaptionConf={spreadFactor:.2,padding:{v:2,h:2},style:{fill:"#786B50",fontFamily:"sans-serif",fontSize:"12px",fontWeight:"bold",fontStyle:"normal"},bound:{style:{stroke:"none"}}};defaultConf.legendBodyConf={spreadFactor:.8,padding:{v:2,h:2},bound:{style:{stroke:"none"}}};defaultConf.legendAxisConf={legendAxisHeight:11,spreadFactor:.4,padding:{v:1,h:1},style:{stroke:"none","stroke-opacity":0,"stroke-width":1},line:{grooveLength:3,offset:8,style:{stroke:"rgba(255, 255, 255, 0.65)","stroke-width":1.5}},shadow:{style:{stroke:"none",fill:(0,_lib.toRaphaelColor)({FCcolor:{alpha:"25,0,0",angle:360,color:"000000,FFFFFF,FFFFFF",ratio:"0,30,40"}})}},bound:{style:{stroke:"none"}}};defaultConf.sliderGroupConf={showTooltip:1,outerCircle:{rFactor:1.4,style:{fill:TRACKER_FILL,stroke:"#757575","stroke-width":3}},innerCircle:{rFactor:.65,style:{fill:TRACKER_FILL,stroke:"#FFFFFF"}}};defaultConf.axisTextItemConf={spreadFactor:.3,padding:{v:1,h:1},style:{fill:"#786B50",fontFamily:"sans-serif",fontSize:"12px",fontWeight:"normal",fontStyle:"normal"}};function normalizePreprocessedData(confArr){var numberFormatter=chart.getFromEnv("number-formatter"),index,length,rawVal;for(index=0,length=confArr.length;index<length;index++){rawVal=confArr[index].maxvalue;if(!rawVal){continue}confArr[index].maxvalue=numberFormatter.getCleanValue(rawVal)}}return{init:function init(options){chart=options.chart},legacyDataParser:function legacyDataParser(data,_extremes){var colormanagerConf={},numberFormatter=chart.getFromEnv("number-formatter"),dataSource=chart.getFromEnv("dataSource"),mapData=dataSource.data,colorConfArr,colorConf,startColor,endColor,index,validColor,length,colorRange,value,dispValue,mapByPercent,isMaxValPresent,extremes=_extremes||{};if(!data){return false}if(chart.defaultDatasetType==="maps"&&(extremes.min===UNDEF||extremes.max===UNDEF)){extremes={min:Infinity,max:-Infinity};mapData&&mapData.forEach((function(dataObj){extremes.min=Math.min(extremes.min,(0,_lib.pluckNumber)(dataObj.value,extremes.min));extremes.max=Math.max(extremes.max,(0,_lib.pluckNumber)(dataObj.value,extremes.min))}))}else if(chart.getName()==="HeatMap"&&(extremes.min===UNDEF||extremes.max===UNDEF)){extremes={min:Infinity,max:-Infinity};dataSource.dataset.forEach((function(dataset){dataset.data&&dataset.data.forEach((function(dataObj){extremes.min=Math.min(extremes.min,(0,_lib.pluckNumber)(dataObj.value,extremes.min));extremes.max=Math.max(extremes.max,(0,_lib.pluckNumber)(dataObj.value,extremes.max))}))}))}colormanagerConf.mapByPercent=mapByPercent=!!(0,_lib.pluckNumber)(data.mapbypercent,0);colorConfArr=data.color||[];if(data.minvalue===UNDEF){data.minvalue=extremes.min!==UNDEF?mapByPercent?0:extremes.min:0}if(data.maxvalue===UNDEF){data.maxvalue=extremes.max!==UNDEF?mapByPercent?100:extremes.max:100}if(data.maxvalue===data.minvalue||extremes.min===Infinity||extremes.max===-Infinity){data.minvalue=0;data.maxvalue=100}isMaxValPresent=false;for(index=0,length=colorConfArr.length;index<length;index++){if(colorConfArr[index].maxvalue){isMaxValPresent=true;break}}if(!isMaxValPresent){colorConfArr=[]}startColor=data.code;colorRange=colormanagerConf.colorRange=[];colormanagerConf.gradient=!!(0,_lib.pluckNumber)(data.gradient,1);if(!colorConfArr.length){if(startColor){endColor=getValidHexColor(startColor);startColor=getValidHexColor()}else{startColor=getValidHexColor();endColor=getOppositeColor(startColor)}colorConfArr.push({code:endColor,maxvalue:data.maxvalue,label:UNDEF})}else{startColor=getValidHexColor(startColor)}normalizePreprocessedData(colorConfArr);colorConfArr=colorConfArr.sort((function _colorConfComparator(m,n){return m.maxvalue-n.maxvalue}));value=dispValue=data.minvalue&&numberFormatter.getCleanValue(data.minvalue);dispValue=(value!==UNDEF||value!==null)&&(mapByPercent?value+PERCENT_STR:numberFormatter.legendValue(value));colorRange.push({code:(0,_lib.dehashify)(startColor),value:value,displayValue:dispValue,label:data.startlabel});for(index=0,length=colorConfArr.length;index<length;index++){colorConf=colorConfArr[index];validColor=getValidHexColor(colorConf.code||colorConf.color);value=dispValue=colorConf.maxvalue;if(isNaN(parseInt(value,10))){continue}dispValue=(value!==UNDEF||value!==null)&&(mapByPercent?value+PERCENT_STR:numberFormatter.legendValue(value));colorRange.push({code:(0,_lib.dehashify)(validColor),value:value,displayValue:dispValue,label:colorConf.label||colorConf.displayvalue})}colorRange[colorRange.length-1].label=data.endlabel||colorConf.label;return colormanagerConf},getDefaultConf:function getDefaultConf(key){return defaultConf[key]}}}();var ColorRange=function(_ComponentInterface){function ColorRange(){var _this;_this=_ComponentInterface.call(this)||this;_this.datasource={};_this.config.legendItemIds=[];return _this}(0,_inheritsLoose2.default)(ColorRange,_ComponentInterface);var _proto=ColorRange.prototype;_proto.configure=function configure(){var colorManager=this,chart=this.getFromEnv("chart"),colorrange,legendType,mapByCategory=this.getFromEnv("dataSource").chart.mapbycategory,nData,showLegend=chart.config.showLegend,colorRangeInstance=chart.getChildren("colorRange")&&chart.getChildren("colorRange")[0];chart.addToEnv("colorManager",colorManager);colorManager.datasource=chart.getFromEnv("dataSource");colorrange=colorManager.datasource.colorrange;colorRangeInstance&&colorRangeInstance.remove({instant:true});if(!showLegend){colorManager.config.legendItemIds=[]}if(chart.defaultDatasetType==="maps"){if(colorrange.gradient&&Number(colorrange.gradient)){legendType=GRADIENT}else if(colorrange.color){legendType=ICON}else{legendType=NONE}}else if(chart.getName()==="TreeMap"){legendType=GRADIENT}else{if(colorrange.gradient&&colorrange.gradient!=="0"&&!Number(mapByCategory)){legendType=GRADIENT}else{legendType=ICON}}switch(legendType){case GRADIENT:legendManager.init({chart:chart});nData=legendManager.legacyDataParser(colorrange);(0,_lib.componentFactory)(chart,_gradientColorRange.default,"colorRange",1,[nData]);colorRangeInstance=chart.getChildren("colorRange")[0];chart.addToEnv("colorRange",colorRangeInstance);if(!nData){colorRangeInstance._dontPlot=true}colorManager.config.legendItemIds=[];colorManager._configureGradientLegend(colorRangeInstance);break;case"icon":(0,_lib.componentFactory)(chart,_colorBucket.default,"colorRange",1,[{colorRange:colorrange,sortLegend:0,mapByCategory:(0,_lib.pluckNumber)(mapByCategory,0),defaultColor:"cccccc",numberFormatter:chart.getFromEnv("number-formatter")}]);chart.addToEnv("colorRange",chart.getChildren("colorRange")[0]);showLegend&&colorManager._addLegendItems();break;case"none":chart.deleteFromEnv("colorManager");colorManager.config.legendItemIds=[]}};_proto._configureGradientLegend=function _configureGradientLegend(colorRangeInstance){var colorManager=this,gradientLegend=colorManager.getFromEnv("chart").getFromEnv("gLegend");if(!gradientLegend){return}gradientLegend.setColorRange(colorRangeInstance);colorManager.addExtEventListener("rangeUpdated",(function(e,d){colorManager.fireEvent("legendUpdate",{"original-event":e,maxMinArray:d,component:"gradientlegend"})}),gradientLegend)};_proto._addLegendItems=function _addLegendItems(){var colorManager=this,config=colorManager.config,chart=colorManager.getFromEnv("chart"),legend=chart.getChildren("legend")[0],colorMap=chart.getFromEnv("colorRange").colorArr,fillColor,lightColor,len=colorMap.length,legendItem,i,lconfig;for(i=0;i<len;i++){lconfig={label:(0,_lib.pluck)(colorMap[i].label,colorMap[i].displayvalue),datasetObj:colorMap[i],index:i};lightColor=(0,_lib.getLightColor)(colorMap[i].code,40);fillColor={FCcolor:{color:colorMap[i].code+","+colorMap[i].code+","+lightColor,ratio:"0,70,30",angle:270,alpha:"100,100,100"}};legendItem=legend.getItem(config.legendItemIds[i]);if(!legendItem){config.legendItemIds.push(legend.createItem(colorManager));legendItem=legend.getItem(config.legendItemIds[i]);legendItem.addEventListener("fc-click",legendItem.itemClickFn)}legendItem.removeLegendState("hidden");colorMap[i].legendItemId=legendItem&&legendItem.getId();legendItem.configure(lconfig);legendItem.setStateCosmetics("default",{symbol:{fill:(0,_lib.toRaphaelColor)(fillColor),rawFillColor:colorMap[i].code}})}for(i=len;i<config.legendItemIds.length;i++){legend.disposeItem(config.legendItemIds[i])}config.legendItemIds.splice(len)};_proto.legendInteractivity=function legendInteractivity(legendItem){var colorManager=this,colorObj=colorManager.getFromEnv("colorRange").colorArr[legendItem.config.index];colorManager.fireEvent("legendUpdate",{legendItem:legendItem,colorObj:colorObj,component:"legend"})};_proto.getColor=function getColor(value){var colorManager=this;return!Number(colorManager.datasource.chart.mapbycategory)&&Number(colorManager.datasource.colorrange.gradient)?{code:colorManager.getColorByValue(value),label:colorManager.getLabelByValue(value)}:colorManager.getColorObj(value)};_proto.getValueRatio=function getValueRatio(){return this.getFromEnv("colorRange").getValueRatio()};_proto.getCumulativeValueRatio=function getCumulativeValueRatio(){return this.getFromEnv("colorRange").getCumulativeValueRatio()};_proto.getBoxFill=function getBoxFill(isVertical){return this.getFromEnv("colorRange").getBoxFill(isVertical)};_proto.getColorByValue=function getColorByValue(value){return this.getFromEnv("colorRange").getColorByValue(value)};_proto.getColorObj=function getColorObj(value){return this.getFromEnv("colorRange").getColorObj(value)};_proto.getLabelByValue=function getLabelByValue(value){return this.getFromEnv("colorRange").getLabelByValue(value)};return ColorRange}(_componentInterface.ComponentInterface);var _default=exports.default=ColorRange;